var express = require('express')
  , stylus = require('stylus');
  
compileStylus = function (str) {
  return stylus(str)
    .set('compress', false);
};
    
app.configure(function(){
  var cwd = process.cwd();
  app.use(stylus.middleware({
    //debug: true,
    force: true,
    src: cwd + '/app/assets/',
    dest: cwd + '/public',
    compile: compileStylus
  }));
  app.use(express.static(cwd + '/public', {maxAge: 86400000}));
  app.set('views', cwd + '/app/views');
  app.set('view engine', 'VIEWENGINE');
  app.set('jsDirectory', '/javascripts/');
  app.set('cssDirectory', '/stylesheets/');
  app.use(express.bodyParser());
  app.use(express.cookieParser());
  app.use(express.session({secret: 'secret'}));
  app.use(express.methodOverride());
  app.use(app.router);
});
